Python raise...from... 是啥?

  调试程序时看某些库的源代码,发现有如下代码读不懂,不理解后面这个from干什么用的。

try:
    ...
except KeyError:
    raise **Error('') from None

try:
    ...
except Exception as exc:
    raise **Error('') from exc

  先看普通写法,控制台会输出什么,结果如下。控制台输出了2个异常发生的位置和原因,同时在2个提示中间输出一句话“在处理上述异常时,又发生了另一个异常”。

try:
    print(1/0)
except Exception as exc:
    raise RuntimeError('程序执行过程中发生错误')

Traceback (most recent call last):
  File "D:/*/tests.py", line 5, in <module>
    print(1/0)
ZeroDivisionError: division by zero

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "D:/*/tests.py", line 7, in <module>
    raise RuntimeError('程序执行过程中发生错误')
RuntimeError: 程序执行过程中发生错误

  再看raise **Error('') from exc写法,控制台输出了什么,结果如下。控制台输出了2个异常发生的位置和原因,同时在2个提示中间输出一句话“上述异常是下列异常的直接原因”。

try:
    print(1/0)
except Exception as exc:
    raise RuntimeError('程序执行过程中发生错误') from exc

Traceback (most recent call last):
  File "D:/WorkSpace/backend/user/tests.py", line 5, in <module>
    print(1/0)
ZeroDivisionError: division by zero

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "D:/WorkSpace/backend/user/tests.py", line 7, in <module>
    raise RuntimeError('程序执行过程中发生错误') from exc
RuntimeError: 程序执行过程中发生错误

  最后看raise **Error('') from None写法,控制台输出了什么,结果如下。控制台只输出了我们写的抛出异常。

try:
    print(1/0)
except Exception as exc:
    raise RuntimeError('程序执行过程中发生错误') from None

Traceback (most recent call last):
  File "D:/WorkSpace/backend/user/tests.py", line 7, in <module>
    raise RuntimeError('程序执行过程中发生错误') from None
RuntimeError: 程序执行过程中发生错误

  总结:from 会为异常对象设置 __cause__ 属性表明异常的是由谁直接引起的。处理异常时发生了新的异常,在不使用 from 时更倾向于新异常与正在处理的异常没有关系。而 from 则是能指出新异常是因旧异常直接引起的。这样的异常之间的关联有助于后续对异常的分析和排查。from 语法会有个限制,就是第二个表达式必须是另一个异常类或实例。如果在异常处理程序或 finally 块中引发异常,默认情况下,异常机制会隐式工作会将先前的异常附加为新异常的 __context__属性。当然,也可以通过with_traceback()方法为异常设置上下文__context__属性,这也能在traceback更好的显示异常信息。from 还有个特别的用法:raise ... from None ,它通过设置 __suppress_context__ 属性指定来明确禁止异常关联。

  在异常处理程序或finally块中引发异常,可以通过from来指定异常因谁引起的。这些手段都是为了得到更友好的异常回溯信息,打印清晰的异常上下文。若要忽略上下文,则可以通过 raise ... from None 来禁止自动显示异常上下文。

posted @ 2022-02-12 22:15  呆贝斯  阅读(144)  评论(0编辑  收藏  举报